
package de.ivu.elect.presentation.ergebniskonflikt;

import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisNichtAusgewaehltException;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisSelectChangeEvent;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonflikt;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId(value = "266", mehrfachVergebenOk = true)
@Named(AbstractErgebnisKonfliktSearchView.COMPONENT_NAME)
public class ErgebnisKonfliktSearchView extends AbstractErgebnisKonfliktSearchView {

  private static final long serialVersionUID = 1L;

  @Inject
  protected ErgebnisSessionSelect ergebnisSelect;

  @PreConditionCheck
  public String checkPreCondition() {
    if (!isErgebnisSelected()) {
      throw new ErgebnisNichtAusgewaehltException();
    }

    return null;
  }

  private boolean isErgebnisSelected() {
    return ergebnisSelect.isSelected();
  }

  protected Ergebnis getErgebnis() {
    return ergebnisSelect.getEntity();
  }

  @Override
  public void presetSearchParameters() {
    searchParameters.setErgebnis(getErgebnis());
  }

  private void resetSearchParameters() {
    searchParameters.setErgebnis(getErgebnis());
  }

  public void onErgebnisSelectChangeEvent(
      @Observes(notifyObserver = Reception.IF_EXISTS) ErgebnisSelectChangeEvent event) {
    resetSearchResult();
    resetSearchParameters();
  }

  @Override
  protected AbstractGebietSecurityFilter<ErgebnisKonflikt> getGebietSecurityFilter() {
    return KEIN_GEBIET_SECURITY_FILTER;
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    // nichts zu tun
  }

  @Override
  public void resetSearchResult() {
    super.resetSearchResult();
  }

}
